package Apache::imsimport;

use strict;
use Apache::Constants qw(:common :http :methods);
use Apache::loncacc;
use Apache::loncommon();
use Apache::Log();
use Apache::lonnet;
use Apache::imsprocessor;
use HTML::Parser;
use HTML::Entities();
use Apache::lonlocal;
use Apache::lonupload;
use File::Basename();
                                                                                            
# ----------------------------------------------------------------  Jscript One
sub jscript_one {
    my ($fullpath,$jsref) = @_;
    $$jsref = <<"END_OF_ONE";
function verify() {
 if ((document.forms.dataForm.newdir.value == '')  || (!document.forms.dataForm.newdir.value)) {
   alert("You must choose a destination directory for the import")
   return false
 }
 if (document.forms.dataForm.source.selectedIndex == 0) {
   alert("You must choose the Course Management System from which the IMS package was exported");
   return false
 }
 return true
}

function nextPage() {
  if (verify()) {
    document.forms.dataForm.submit()
  }
}

function createWin() {
  document.dataForm.newdir.value = "";
  newWindow = window.open("","CreateDir","HEIGHT=400,WIDTH=750,scrollbars=yes")
  newWindow.document.open()
  newWindow.document.write("<html><head><title>Create IMS import directory</title><meta http-equiv='pragma' content='no-cache'>\\n")
  newWindow.document.write("</head><body bgcolor='#CCFFDD' topmargin='0' leftmargin='0' marginheight='0'marginwidth='0' rightmargin='0'>\\n")
  newWindow.document.write("<img border='0' src='/adm/lonInterFace/author.jpg' alt='[Author Header]'>\\n")
  newWindow.document.write("<table border='0' cellspacing='0' cellpadding='0' width='600' bgcolor='#CCFFDD'>\\n")
  newWindow.document.write("<tr><td width='2'>&nbsp;</td><td width='3'>&nbsp;</td>\\n")
  newWindow.document.write("<td><h3>Location: <tt>$fullpath</tt></h3><h3>New Directory</h3></td></tr>\\n")
  newWindow.document.write("<tr><td width='2'>&nbsp;</td><td width='3'>&nbsp;</td>\\n")
  newWindow.document.write("<td><form name='fileaction' action='/adm/cfile' method='post'>\\n")
  newWindow.document.write("<font face='arial,helvetica,sans-serif'>Enter the name of the new directory where you will store the contents of your IMS package.<br /><br />")
  newWindow.document.write("<input type='hidden' name='filename' value='$fullpath'>")
  newWindow.document.write("<input type='hidden' name='action' value='newdir'>")
  newWindow.document.write("<input type='hidden' name='callingmode' value='imsimport'>")
  newWindow.document.write("$fullpath<input type='text' name='newfilename' value=''/>")
  newWindow.document.write("<input type='button' value='Go' onClick='document.fileaction.submit();' />")
  newWindow.document.write("</td></tr>\\n")
  newWindow.document.write("</table></body></html>")
  newWindow.document.close()
  newWindow.focus()
}

END_OF_ONE

}

# ----------------------------------------------------------------  Jscript Two
sub jscript_two {
    my ($javascript,$user,$dom,$numcrs) = @_;
    my %crsentry = ();
    my $course_list;
    my $title_list;
    my @crslist = ();
    &get_ccroles($user,$dom,\%crsentry,\@crslist);
    if (@crslist > 0) {
        $crsentry{$crslist[0]} =~ s/("|,)//g;
        $title_list = '"'.$crsentry{$crslist[0]}.'"';
        if (@crslist > 1) {
            for (my $i=1; $i<@crslist; $i++) {
                $crsentry{$crslist[$i]} =~ s/("|,)//g;
                $title_list .= ',"'.$crsentry{$crslist[$i]}.'"';
            }
        }
    }
    $course_list = '"'.join('","',@crslist).'"';
    $$numcrs = @crslist;

    $$javascript = qq#

function checkCourse() {
  courseID_array = new Array($course_list)
  courseTitle_array = new Array($title_list)
  var step2Form = document.forms.pickoptions
  var conditionType = step2Form.conditions.value
  var curVal = step2Form.targetcourse.options[step2Form.targetcourse.selectedIndex].value
  if (curVal == -1) {
      if ( conditionType == 'both'  )  {
          if ( step2Form.board.checked == true || step2Form.users.checked == true ) {
              setCourse(step2Form,'add')
          }
      }
      if ( conditionType == 'users'  )  {
          if ( step2Form.users.checked == true ) {
              setCourse(step2Form,'add')
          }
      }
      if ( conditionType == 'board'  )  {
          if ( step2Form.board.checked == true ) {
              setCourse(step2Form,'add')
          }
      }
  }
  else { 
      if ( conditionType == 'both'  )  {
          if ( step2Form.board.checked == false && step2Form.users.checked == false ) {
              setCourse(step2Form,'clear')
          }
      }
      if ( conditionType == 'users'  )  {
          if ( step2Form.users.checked == false ) {
              setCourse(step2Form,'clear')
          }
      }
      if ( conditionType == 'board'  )  {
          if ( step2Form.board.checked == false ) {
              setCourse(step2Form,'clear')
          }
      }
  }
}

function setCourse(step2Form,call) {
    step2Form.targetcourse.length = 0
    if (call == 'add') {
        step2Form.targetcourse.length = 0
        step2Form.targetcourse.options[0] = new Option("Please Select","0",true,true)
        for (var i=0; i<courseID_array.length; i++) {
            step2Form.targetcourse.options[i+1] = new Option(courseTitle_array[i],courseID_array[i],false,false)
        }
        step2Form.targetcourse.selectedIndex = 0
    }
    else {
        step2Form.targetcourse.options[0] = new Option("Not required","-1",true,true)
        step2Form.targetcourse.selectedIndex = 0
    }
}


function setOptions(caller,itemnum) {
  var numCrs = $$numcrs
  var opForm = document.forms.pickoptions
  var menu = 1 + itemnum*2
  opForm.elements[menu].length = 0
  if (opForm.elements[itemnum*2].checked == true) {
    if (caller == "board") {
      opForm.elements[menu].options[0] = new Option("Select","-1",true,true)
      opForm.elements[menu].options[1] = new Option("Import topics only","topics",true,true)
      opForm.elements[menu].options[2] = new Option("Import topics + posts (with author)","allpost",true,true)
      opForm.elements[menu].options[3] = new Option("Import topics + posts (no author)","allanon",true,true)
    }
    else { 
      if (caller == "users") {
        opForm.elements[menu].length = 0
        opForm.elements[menu].options[0] = new Option("Select","-1",true,true)
        opForm.elements[menu].options[1] = new Option("Enroll students only","students",true,true)
        opForm.elements[menu].options[2] = new Option("Enroll all users","all",true,true)
      }
    }
  }
  else {
    opForm.elements[menu].options[0] = new Option("Not required","0",true,true)
  }
  opForm.elements[menu].selectedIndex = 0
  if (numCrs > 0) {
      checkCourse()
  }
}

function verify(caller) {
  var numCrs = $$numcrs
  var opForm = document.forms.pickoptions
  var totcheck = 0;
  var totchg = 0;
  for (var i=0; i<caller; i++) {
    if (opForm.elements[2*i].checked == true) {
      totcheck ++
      if (opForm.elements[2*i].name == "board") { 
        if (opForm.elements[2*i+1].selectedIndex == 0) {     
          alert("You must select one of the additional options when importing Discussion Boards ")
          return false
        }
        if (numCrs == 0) {
            opForm.elements[2*i].checked = false
            totchg ++
        }
        else {
          if (opForm.targetcourse.selectedIndex == 0) {
            alert("You must select a target course when importing Discussion Boards")
            return false
          }
        }
      }
      if (opForm.elements[2*i].name == "users") {
        if (opForm.elements[2*i+1].selectedIndex == 0) {     
          alert("You must select one of the additional options when importing Enrollment")
          return false
        }
        if (numCrs == 0) {
            opForm.elements[2*i].checked = false
            totchg ++ 
        }
        else {
          if (opForm.targetcourse.selectedIndex == 0) {
            alert("You must select a target course when importing enrollment information")
            return false
          }
        }
      }
    }
  }
  if (totcheck == 0) {
    alert("You must check the Checkbox for at least one Content Type");
    return false
  }
  return true
}

function nextPage(caller) {
  if (verify(caller)) {
    document.forms.pickoptions.submit()
  }
}

#;

}

# ----------------------------------------------------------------  Jscript Three
sub jscript_three {
    my $javascript = shift;
}

# ---------------------------------------------------------------- Display One
sub display_one {
    my ($r,$uname,$fn,$fullpath) = @_;
    $r->print(<<"END_OF_ONE");
<form name="dataForm" method="post">
<table border='0' bgcolor='#CCFFDD' cellspacing='0' cellpadding ='0' width='100%'>
    <tr>
     <td colspan='2'>
      <table border='0' cellspacing='0' cellpadding='0'>
       <tr>
        <td colspan='2'  align='left'>&nbsp;
        </td>
       </tr>
       <tr bgcolor='#ccddaa'>
        <td valign='middle'><img src='/res/adm/pages/bl_step1.gif'>&nbsp;
        </td>
        <td width='100%' align='left'>&nbsp;&nbsp;
         <font face='arial,helvetica,sans-serif'><b>Specify the Course Management system used to create the package.</b>&nbsp;&nbsp;
         </font>
       </td>
      </tr>
      <tr>
       <td colspan='2'>&nbsp;</td>
      </tr>
      <tr>
       <td>&nbsp;</td>
       <td>
        <font face='Arial,Helvetica,sans-serif'>
Please choose the CMS used to create your IMS content package.&nbsp;&nbsp;
        <select name="source">
         <option value='-1' selected="true">Please select
         <option value='bb5'>Blackboard 5
         <option value='angel'>ANGEL
        </select>
        </font>
       </td>
      </tr>
      <tr>
       <td colspan='2'>&nbsp;</td>
      </tr>
      <tr>
       <td colspan='2'>&nbsp;</td>
      </tr>
      <tr bgcolor='#ccddaa'>
       <td valign='middle'><img src='/res/adm/pages/bl_step2.gif'>
       </td>
       <td width='100%' align='left'>&nbsp;&nbsp;
        <font face='arial,helvetica,sans-serif'><b>Create a directory where you will unpack your IMS package.</b>&nbsp;&nbsp;</font></td>
      </tr>
      <tr>
       <td colspan='2'>&nbsp;</td>
      </tr>
       <td>&nbsp;</td>
       <td>
        <font face='Arial,Helvetica,sans-serif'>
Please choose a destination LON-CAPA directory in which to store the contents of the IMS package file. <input type="button" name="createdir" value="Create Directory" onClick="javascript:createWin()"><input type="hidden" name="newdir" value=""></font>
       </td>
      </tr>
      <tr>
       <td colspan='2'>&nbsp;<br /><br /></td>
      </tr>
      <tr>
       <td>&nbsp;</td>
       <td><font face='arial,helvetica,sans-serif'>If you have selected the CMS used to create the IMS package, and have created a destination directory, click the 'Proceed' button to continue the IMS package upload process.</font></td>
      </tr>
      <tr>
       <td colspan='2'>
          <input type="hidden" name="uploaduname" value="$uname">
          <input type="hidden" name="filename" value="$fn">
          <input type="hidden" name="phase" value="three">
       </td>
      </tr>
      <tr>
       <td colspan='2'>&nbsp;</td>
      </tr>
      <tr>
       <td colspan='2'>
        <table border='0' cellspacing='0' cellpadding='0' width="100%">
         <tr>
          <td align='left'>
           <input type='button' name='exitpage' value='Exit now' onClick="javascript:location.href='$fullpath'">
          </td>
          <td align='right'>
           <input type="button" name="nextpage" value="Proceed" onClick="javascript:nextPage()">
          </td>
         </tr>
        </table>
       </td>
      </tr>
     </table>
    </td>
   </tr>
  </table>
</form>
END_OF_ONE
}

# ---------------------------------------------------------------- Display Two
sub display_two {
    my ($r,$zipupload,$areas,$areaname,$cmsmap,$uname,$newdir,$numcrs,$fullpath) = @_;
    &Apache::loncommon::get_unprocessed_cgi($ENV{'QUERY_STRING'},['folder','source']);
    my $cms = $ENV{'form.source'};
    my $dirname = $ENV{'form.newdir'};
    my $tempdir = &Apache::imsprocessor::create_tempdir('CSTR',$dirname,'');
    my $fname = &Apache::imsprocessor::uploadzip('CSTR',$tempdir,$zipupload);
    my $unzip_result = '';
    my $manifest_result = '';
    unless ($tempdir eq '') {
        $unzip_result = &Apache::imsprocessor::expand_zip($tempdir,$fname);
    }
    my %resources = ();
    my %items = ();
    my %hrefs = ();
    my %resinfo = ();
    my %count = ();
    my @bgcolors = ("#eeeeee","#dddddd");

    my $counter = 0;
    my $iter = 0;
    my %count = (
                announce => 0,
                board => 0,
                doc => 0,
                extlink => 0,
                msg => 0,
                pool => 0,
                quiz => 0,
                staff => 0,
                survey => 0,
                users => 0,
                );
    my $conditions;

    if ($unzip_result eq 'ok') {
        $manifest_result = &Apache::imsprocessor::process_manifest($cms,$tempdir,\%resources,\%items,\%hrefs,\%resinfo);
        if ($manifest_result eq 'ok') {
            foreach my $res (sort keys %resources) {
                if ($cms eq 'bb5') {
                    foreach my $area (keys %{$$cmsmap{$cms}}) {
                        if ($resources{$res}{type} eq $$cmsmap{$cms}{$area}) {
                            $count{$area} ++;
                        }
                    }
                } elsif ($cms eq 'angel') {
                    foreach my $area (keys %{$$cmsmap{$cms}}) {
                        if ($area eq 'doc') {
                            if (grep/^$resources{$res}{type}$/,@{$$cmsmap{$cms}{doc}}) {
                                $count{$area} ++;
                            }
                        } elsif ($resources{$res}{type} eq $$cmsmap{$cms}{$area}) {
                            $count{$area} ++;                                
                        }
                    }
                }
            }
            if ($count{board} > 0) {
                if ($count{users} > 0) {
                    $conditions = 'both';
                } else {
                    $conditions = 'board';
                }
            } elsif ($count{users} > 0) {
                $conditions = 'users';
            } else {
                $conditions = 'none';
            }

            $r->print(<<ENDBLOCK);
<form name="pickoptions" method="post">
  <table border='0' cellspacing='0' cellpadding ='0' width='100%'>
   <tr>
    <td colspan='2'>
     <table border='0' cellspacing='0' cellpadding='0'>
      <tr>
       <td colspan='2'  align='left'>&nbsp;
       </td>
      </tr>
      <tr bgcolor='#ccddaa'>
       <td valign='middle'><img src='/res/adm/pages/bl_step3.gif'>
       </td>
       <td width='100%' align='left'>&nbsp;&nbsp;
        <font face='arial,helvetica,sans-serif'><b>Choose which content types you wish to import</b></font>
       </td>
      </tr>
      <tr>
       <td colspan='2'>&nbsp;</td>
      </tr>
      <tr>
       <td>&nbsp;</td>
       <td>
        <table border='0' cellspacing='0' cellpadding='1' bgcolor='#000000'>
         <tr>
          <td>
           <table border='0' cellspacing='0' cellpadding='0' bgcolor='#ffffff' width='100%'>
            <tr>
             <td>
              <table border='0' cellspacing='1' cellpadding='1' bgcolor='#ffffff' width='100%'>
               <tr bgcolor='#ccddaa'>
                <td align='center'><font face='arial,helvetica,sans-serif'><b>Import?</b></font></td>           
                <td align='center'><font face='arial,helvetica,sans-serif'><b>Content type</b></font></td>
                <td align='center'><font face='arial,helvetica,sans-serif'><b>Additional options</b></font></td>
               </tr>
ENDBLOCK
            foreach my $area (@{$areas}) {
                if ($count{$area} > 0) {
                    my $count_tag = 'flag_'.$counter;
                    $r->print("               <tr bgcolor='@bgcolors[$iter]'>
                <td align='left'><font face='arial,helvetica,sans-serif'><input name='$area' type='checkbox' ");
                    if ($area eq 'board' || $area eq 'users') {
                        $r->print(qq|onClick='javascript:setOptions("$area","$counter")'|);
                    }
                    $r->print("/></font></td>
                <td align='left'><font face='arial,helvetica,sans-serif'>&nbsp;&nbsp;$$areaname{$area}&nbsp;&nbsp; - $count{$area} item(s)</font></td>");
                    if ($area eq 'board') {
                        $r->print("            <td align='left'><font face='arial,helvetica,sans-serif'>&nbsp;&nbsp;
                 <select name='db_handling'>
                  <option value='-2'>&lt;-- Check Import first
                 </select></font>
                </td>");
                    } elsif ($area eq 'users') {
                        $r->print("            <td align='left'><font face='arial,helvetica,sans-serif'>&nbsp;&nbsp;
                 <select name='user_handling'>
                  <option value='-2'>&lt;-- Check Import first
                 </select>
                 </font>        
                </td>");
                    } else {
                        $r->print("            <td align='left'><font face='arial,helvetica,sans-serif'>&nbsp;&nbsp;None<input type='hidden' name='$count_tag' /></font></td>");
                    }
                    $counter ++;
                    $iter = $counter%2;
                }
            }
            $r->print(<<ENDBLOCKTWO);
               </tr>
              </table>
             </td>
            </tr>
           </table>
          </td>
         </tr>
        </table>
       </td>
      </tr>
      <tr>
       <td colspan='2'  align='left'>&nbsp;
       </td>
      </tr>
ENDBLOCKTWO
            if ($count{board} + $count{users} > 0) {
                $r->print("
      <tr bgcolor='#ccddaa'>
       <td valign='middle'><img src='/res/adm/pages/bl_step4.gif'>
       </td>
       <td width='100%' align='left'>&nbsp;&nbsp;
        <font face='arial,helvetica,sans-serif'><b>Choose a course to receive bulletin boards and user enrollment.</b></font>
       </td>
      </tr>
      <tr>
       <td colspan='2'>&nbsp;</td>
      </tr>
                ");
                if ($$numcrs > 0) {
                    $r->print("      <tr>
       <td>&nbsp;</td>
       <td><font face='arial,helvetica,sans-serif'>A listing of possible course targets will be displayed if import of bulletin boards and/or enrollment is checked above (step 3). If you do not plan to import either of these content types, there is no need to specify a course.
<br /><br />
Choose course:&nbsp;&nbsp;
                 <select name='targetcourse'>
                  <option value='-1'>Not required
                 </select></font>
       </td>
      </tr>
");
                } else {
                    $r->print("       <tr>
<td>&nbsp;</td>
<td><font face='arial,helvetica,sans-serif'>You do not have active course coordinator status in any LON-CAPA courses currently, so bulletin boards and enrollment information included in your IMS package will be discarded, regardless of your import choice for these two items above (step 3). If you wish to import bulletin boards and/or user information into LON-CAPA please click 'Exit now' to quit the current IMS import process, and contact your domain coordinator and request a course coordinator role in a LON-CAPA course into which you can upload bulletin boards and/or enroll users.</font>
        ");
                }
            }
            $r->print(<<ENDBLOCK);
      <tr>
       <td colspan='2'>&nbsp;<br /><br /></td>
      </tr>
      <tr>
       <td>&nbsp;</td>
       <td><font face='arial,helvetica,sans-serif'>Once you have checked the checkboxes for all areas you wish to import from the IMS package, and selected additional options (if available) you should click the 'Import package' button.</font></td>
      </tr>
      <tr>
       <td colspan='2'>&nbsp;
          <input type="hidden" name="newdir" value="$ENV{'form.newdir'}" />
          <input type="hidden" name="conditions" value="$conditions" />
          <input type="hidden" name="source" value="$cms" />
          <input type="hidden" name="tempdir" value="$tempdir" />
          <input type="hidden" name="uploaduname" value="$uname">
          <input type="hidden" name="filename" value="$fname">
          <input type="hidden" name="phase" value="four" />
ENDBLOCK
            if ($count{board} == 0) {
                $r->print('            <input type="hidden" name="board" value="" />'."\n");
            }
            if ($count{users} == 0) {
                $r->print('            <input type="hidden" name="users" value="" />'."\n");
            }
            $r->print(<<ENDDOCUMENT);
       </td>
      </tr>
      <tr>
       <td colspan='2'>
        <table border='0' cellspacing='0' cellpadding='0' width="100%">
         <tr>
          <td align='left'>
           <input type='button' name='exitpage' value='Exit now' onClick="javascript:location.href='$fullpath'">
          </td>
          <td align='right'>
           <input type="button" name="nextpage" value="Import package" onClick="javascript:nextPage($counter)">
          </td>
         </tr>
        </table>
       </td>
      </tr>
     </table>
    </td>
   </tr>
  </table>
ENDDOCUMENT
        } else {
            $r->print("Unpacking of your IMS package failed because an IMS manifest file was not located in the package\n");
        }
    } else {
        $r->print("Processing of your IMS package failed because the file you uploaded could not be unzipped\n");
    }
}

# ---------------------------------------------------------------- Display Three
sub display_three {
    my ($r,$uname,$udom,$areas,$areaname,$cmsmap,$destdir,$newdir) = @_;
    my $crs = '';
    my $cdom = '';
    my $chome = '';
    my $db_handling = '';
    my $timenow = time; 
    my $announce_handling = 'ok';
    my $cms = $ENV{'form.source'};
    if ( defined($ENV{'form.bb_crs'}) ) {
        ($cdom,$crs) = split/\//,$ENV{'form.bb_crs'};
        $chome = &Apache::lonnet::homeserver($crs,$cdom);
    } 
    if ( defined($ENV{'form.bb_handling'}) ) {
        $db_handling = $ENV{'form.bb_handling'};
    }
    my $user_crs = '';
    my $user_cdom = '';
    my $user_handling = '';
    if ( defined($ENV{'form.user_crs'}) ) {
        ($user_cdom,$user_crs) = split/\//,$ENV{'form.user_crs'};
    }
    if ( defined($ENV{'form.user_handling'}) ) {
        $user_handling = $ENV{'form.user_handling'};
    }
    my $seqstem = "/res/$udom/$uname/$newdir";
    my %imports = ();
    my @targets = ();
    my %resources = ();
    my %items = ();
    my %hrefs = ();
    my %urls = ();
    my %resinfo = ();
    my %total = (
                   page => 0,
                   prob => 0,
                   seq => 0,
                   board => 0,         
                   quiz => 0,
                   surv => 0,
    );

    my @pages = ();
    my @sequences = ();
    my @resrcfiles = ();

    my $tempdir = $ENV{'form.tempdir'};

    foreach my $area (@{$areas}) {
        if (defined($ENV{"form.$area"}) ) {          
            if ($cms eq 'angel' && $area eq 'doc') {
                foreach (@{$$cmsmap{$cms}{$area}}) {
                    $imports{$_} = 1;
                }
            } else {
                $imports{$$cmsmap{$cms}{$area}} = 1;
            }
            if ($area eq 'board') {
                $db_handling = $ENV{'form.db_handling'};
            } elsif ($area eq 'users') {
                $user_handling = $ENV{'form.user_handling'};
            }
        }
    }
    my $manifest_result = &Apache::imsprocessor::process_manifest($cms,$tempdir,\%resources,\%items,\%hrefs,\%resinfo);
    if ($manifest_result eq 'ok') {
        &Apache::imsprocessor::target_resources(\%resources,\%imports,\@targets);
        my $copy_result = &Apache::imsprocessor::copy_resources('CSTR',$cms,\%hrefs,$tempdir,\@targets,\%urls,$crs,$cdom,$chome,$destdir,$timenow);

        my @boards = ();
        my @announcements = ();
        my @quizzes = ();
        my @surveys = ();
        my @groups = ();
        my %messages = ();
        my @timestamp = ();
        my %boardnum = ();
        my @topurls = ();
        my @topnames = ();

        &Apache::imsprocessor::process_resinfo($cms,'CSTR',$tempdir,$destdir,\%items,\%resources,\@boards,\@announcements,\@quizzes,\@surveys,\@groups,\%messages,\@timestamp,\%boardnum,\%resinfo,$udom,$uname,$cdom,$crs,$db_handling,$user_handling,\%total,$newdir,$seqstem,\@resrcfiles);
   
        &Apache::imsprocessor::build_structure($cms,'CSTR',$destdir,\%items,\%resinfo,\%resources,\%hrefs,$udom,$uname,$newdir,$timenow,$cdom,$crs,\@timestamp,\%total,\@boards,\@announcements,\@quizzes,\@surveys,\%boardnum,\@pages,\@sequences,\@topurls,\@topnames);

        $r->print("<h3>Step 3: Publish your new LON-CAPA materials</h3>");

        if ($cms eq 'bb5') {
            $r->print("<font face='arial,helvetica,sans-serif'>Your IMS package has been processed successfully. A total of $total{seq} sequences, $total{page} pages, $total{board} bulletin boards, $total{quiz} quizzes, $total{surv} surveys and $total{prob} problems have been created.<br /><br />\n");
        } elsif ($cms eq 'angel') {
            $r->print("<font face='arial,helvetica,sans-serif'>Your IMS package has been processed successfully. A total of $total{seq} sequences, $total{page} pages, and $total{board} bulletin boards have been created.<br /><br />\n");
        }
#        system (" rm -r -f $destdir/temp");
    } elsif ($manifest_result eq 'nomanifest') {
        $r->print("<font face='arial,helvetica,sans-serif'>Processing of your IMS package failed, because the IMS content package did not contain an IMS manifest file .");
    }
}

# ---------------------------------------------------------------- Get LON-CAPA Course Coordinator roles for this user
sub get_ccroles {
    my ($user,$dom,$crsentry,$crslist) = @_;
    my %roles = ();
    unless ($user eq '') {
        %roles = &Apache::lonnet::dump('roles',$dom,$user);
    }
    my $iter = 0;
    my @codes = ();
    my %courses = ();
    my @crslist = ();
    my %descrip =();
    foreach my $key (keys %roles ) {
        if ($key =~ m/^\/(\w+)\/(\w+)_cc$/) {
            my $cdom = $1;
            my $crs = $2;
            my $role_end = 0;
            my $role_start = 0;
            my $active_chk = 1;
            if ( $roles{$key} =~ m/^cc_(\d+)/ ) {
                $role_end = $1;
                if ( $roles{$key} =~ m/^cc_($role_end)_(\d+)$/ )
                {
                    $role_start = $2;
                }
            }
            if ($role_start > 0) {
                if (time < $role_start) {
                    $active_chk = 0;
                }
            }
            if ($role_end > 0) {
                if (time > $role_end) {
                    $active_chk = 0;
                }
            }
            if ($active_chk) {
                my $currcode = '';
                my %settings = &Apache::lonnet::get('environment',['internal.coursecode','description'],$cdom,$crs);
                if (defined($settings{'description'}) ) {
                    $descrip{$crs} = $settings{'description'};
                } else {
                    $descrip{$crs} = 'Unknown';
                }
                if (defined($settings{'internal.coursecode'}) ) {
                    $currcode = $settings{'internal.coursecode'};
                    if ($currcode eq '') {
                        $currcode = "____".$iter;
                        $iter ++;
                    }
                } else {
                    $currcode = "____".$iter;
                    $iter ++;
                }
                unless (grep/^$currcode$/,@codes) {
                    push @codes,$currcode;
                    @{$courses{$currcode}} = ();
                }
                push @{$courses{$currcode}}, $cdom.'/'.$crs;
            }
        }
    }
    foreach my $code (sort @codes) {
        foreach my $crsdom (@{$courses{$code}}) {
            my ($cdom,$crs) = split/\//,$crsdom;
            my $showcode = '';
            unless ($code =~m/^____\d+$/) {  $showcode = $code; }
            $$crsentry{$crsdom} = $showcode.':'.$descrip{$crs};
            push @{$crslist}, $crsdom;
        }
    }
    return;
}

# ---------------------------------------------------------------- Main Handler
sub handler {
    my $r=shift;
    my $uname;
    my $udom;
    my $javascript = '';
    my $page_name = '';
    my $current_page = '';
    my $loadentries = '';
    my $qcount = '';

# get personal information for this user
    my $user=$ENV{'user.name'};
    my $dom=$ENV{'user.domain'};

#
# re-attach user
#
    if ($ENV{'form.uploaduname'}) {
        $ENV{'form.filename'}='/priv/'.$ENV{'form.uploaduname'}.'/'.
            $ENV{'form.filename'};
    }
    ($uname,$udom)=
        &Apache::loncacc::constructaccess($ENV{'form.filename'},
                                          $r->dir_config('lonDefDomain'));
    unless (($uname) && ($udom)) {
        $r->log_reason($uname.' at '.$udom.
                       ' trying to publish file '.$ENV{'form.filename'}.
                       ' - not authorized',
                       $r->filename);
        return HTTP_NOT_ACCEPTABLE;
    }
                                                                                             
    my $fn;
    if ($ENV{'form.filename'}) {
        $fn=$ENV{'form.filename'};
        $fn=~s/^http\:\/\/[^\/]+\///;
        $fn=~s/^\///;
        $fn=~s/(\~|priv\/)(\w+)//;
        $fn=~s/\/+/\//g;
    } else {
        $r->log_reason($ENV{'user.name'}.' at '.$ENV{'user.domain'}.
                       ' unspecified filename for upload', $r->filename);
        return HTTP_NOT_FOUND;
    }
    my $zipupload = '/home/'.$uname.'/public_html'.$fn;
    my $pathname = &File::Basename::dirname($fn);
    my $fullpath = '/priv/'.$uname.$pathname;
    unless ($pathname eq '/') {
        $fullpath .= '/';
    }
    my $loadentries = '';

    my @areas = ();
    my %cmsmap = ();
    my %areaname = ();
    my $numcrs = 0;
             
    &Apache::imsprocessor::ims_config(\@areas,\%cmsmap,\%areaname);
# ----------------------------------------------------------- Start page output
    &Apache::loncommon::content_type($r,'text/html');
    $r->send_http_header;

    if ($ENV{'form.phase'} eq 'two') {
        &jscript_one($fullpath,\$javascript,$uname,$udom);
    } elsif ($ENV{'form.phase'} eq 'three') {
        &jscript_two(\$javascript,$user,$dom,\$numcrs);
    } elsif ($ENV{'form.phase'} eq 'four') {
        &jscript_three(\$javascript);
    }
    $r->print("<html><head><title>LON-CAPA Construction Space</title><script type=\"text/javascript\">\n//<!--\n$javascript\n// --></script>\n</head>");
                                                                                             
    $r->print(&Apache::loncommon::bodytag('Upload IMS package to Construction Space',undef,$loadentries));
                                                                                             
    if (($uname ne $ENV{'user.name'}) || ($udom ne $ENV{'user.domain'})) {
        $r->print('<h3><font color=red>'.&mt('Co-Author').': '.$uname.
                  &mt(' at ').$udom.'</font></h3>');
    }   
    if ($ENV{'form.phase'} eq 'two') {
        my $flag = &Apache::lonupload::phasetwo($r,$fn,$uname,$udom,'imsimport');
        if ($flag eq 'ok') {
            &display_one($r,$uname,$fn,$fullpath);
        }
    } elsif ( ($ENV{'form.phase'} eq 'three') || ($ENV{'form.phase'} eq 'four') ) {
        my $docroot = $ENV{'form.newdir'};
        my $newdir = '';
        if ($docroot =~ m|public_html/(.+)$|) {
            $newdir = $1;
        }
        if ($ENV{'form.phase'} eq 'three') {
            &display_two ($r,$zipupload,\@areas,\%areaname,\%cmsmap,$uname,$newdir,\$numcrs,$fullpath);
        } elsif ($ENV{'form.phase'} eq 'four') {
            &display_three ($r,$uname,$udom,\@areas,\%areaname,\%cmsmap,$docroot,$newdir);
        }
    } else {
        &Apache::lonupload::phaseone($r,$fn,$uname,$udom,'imsimport');
    }
    $r->print('</body></html>');
    return OK;
}
1;
__END__
